<%
' Sendmail CDOSYS (Windows 2000 / XP)
' Author: Matthew Tagg (matt@webafrica.co.za)
' Company: Diginet Web Africa (http://www.webafrica.co.za/)
' Date: 10 July 2002
' This version date: 23 January 2003
' Version: 1.27
'
' Parameters:
'     (Required)
'        cdoTo: Recipient email address
'        cdoFrom: From email address
'
'     (Optional)
'        cdoCC: CC (Carbon Copy) email address
'        cdoBCC: BCC (Blind Carbon Copy) email address
'        cdoSubject: Subject of the email
'        cdoEmailURL: Create an HTML Email from a URL (Optional)
'        cdoSuccessURL: URL for success page (Optional)
'        cdoFailureURL: URL for failure page (Optional)
'        cdoTextBody: Specifies a Text body (Optional)
'        cdoHtmlBody: Specifies a Html body (Optional)
'
' Notes:
'     All email address (cdoTo, cdoFrom, cdoCC, cdoBCC) can take any of the following forms:
'        "Joe Soap" <jsoap@example.com>
'        <jsoap@example.com>
'        jsoap@example.com
'
'     Multiple recipients can be also specified as well:
'        "Joe Soap" <jsoap@example.com>, anotherguy@example.com, "One More" <1more@example.com>
'
'     All email addresses in your forms field's can include "#" instead of "@"
'     This prevents automated email spiders from grabbing your addresses:
'        "Joe Soap" <jsoap#example.com">
'     
'     This code makes a relative URL usefull for your Success and Failure URL's
'        Left(Request.ServerVariables("SCRIPT_NAME"), _
'        InStrRev(Request.ServerVariables("SCRIPT_NAME"), "/"))
'     If you do not use this then your success and failure pages must lie in the same directory
'     as this script, or you must use absolute path name for your success / failure URLS.
'
' Troubleshooting
'     - See documentation
'
' Todo:
'     - AuthList not implemented
'
' Variables:
'
' ========== REQUIRED VARIABLES ==================
 
SMTPServer           = "localhost"
                     ' Mail server for sending mail on eg. "mail.myisp.com"
'INACTIVE
'AuthList             = Array("webafrica.co.za", "mydomain.com", "test@hotmail.com")
                     ' Email Authentication List 
                     ' Only mail containing these strings on the RHS (Right Hand Side)
                     ' of the "TO" address will be sent. This is to prevent spammers from
                     ' abusing your script.
                     ' Examples:
                     '    WILL SEND: james@mydomain.com,  test@hotmail.com
                     '    WILL NOT SEND: mydomain.com@anotherdomain.com, joe@hotmail.com

' ========== OPTIONAL VARIABLES ==================

HTMLMail             = 1
                     ' 0 = Plaintext
                     ' 1 = HTML Mail
AllowPrefix          = ""
                     ' This string must appear before at the start of all your form fields
                     ' if you want them to be INcluded in the the email or set to null
                     ' if you wish to include all fields.
                     ' Values: 
                     '     ""         : ALLOWS [ALL] fields unless specifically DENIED.
                     '     any string : DENIES [ALL] fields are unless they contain 
                     '                  the specified string value as a prefix.
DenyPrefix           = "_"
                     ' This string must appear before at the start of all your form fields
                     ' if you want them to be EXcluded from the email.
                     ' Values: 
                     '     ""         : Has no effect
                     '     any string : DENIES a field containg the specified string
                     '                  value as a prefix.

                     ' This is a list of Fields we never want to see in our email
DenyList             = Array("cdoTo","cdoFrom", "cdoCC", "cdoBCC", _
                       "cdoSubject", "cdoEmailURL", "cdoFailureURL","cdoSuccessURL")

DefaultFrom          = "Nobody <nobody@" & smtpserver & ">"
                     ' In the case no From field is specified, use this instead of 
                     ' generating and error
DebugEnable          = 0
                     ' Toggles debugging mode
                     ' 0 = Off
                     ' 1 = On
PreserveCookies      = 1
                     ' Toggles whether current cookies are sent when requesting an URL by email.
                     ' Session info is stripped as it needs to run in its own session.
                     ' 0 = Off
                     ' 1 = On

' ========== CONSTANTS (DONT CHANGE) ==================
ParamList            = Array("cdoTo", "cdoFrom", "cdoCC", "cdoBCC", _
                       "cdoSubject", "cdoEmailURL", "cdoSuccessURL","cdoFailureURL")

If DebugEnable Then On Error Goto 0 Else On Error Resume Next

Function InDenyList(FieldName)                     ' Returns True if FieldName is in DenyList
   InDenlyList = False
   For Each Value In DenyList
      If StrComp(Value, FieldName, vbTextCompare) = 0 Then InDenyList = True
   Next
End Function

Function RequestEx(Field)                             ' Extended Request: Returns a value
   RF = Request(Field)                                ' for a field even if aliased
   nErr = 0                                           ' Infinite loop protection but
                                                      ' no nested loop protection
   Do While (InStr(RF, "[") > 0 AND InStr(RF, "]") > 0) AND nErr <> 10
      lPos = InStr(RF, "[")
      rPos = InStr(RF, "]")
      If (lPos < rPos) Then
         Rf = Left(Rf, lPos-1) & RequestEx(Mid(RF, lPos+1 , rPos-lPos-1)) & Mid(RF, rPos+1) 
      End If
      nErr = nErr + 1
   Loop
   If IsNull(RF) Then RequestEx = "" Else RequestEx = Rf
End Function

Function emailAddrFrom(Email)
   If IsNull(Email) or IsEmpty(Email) Then
      emailAddrFrom = DefaultFrom
   Else
      emailAddrFrom = Email
   End If
End Function

Function emailAddr(Email)
   em = Replace(Email, "#", "@")
   If Instr(em, "@") = 0  Then
      em = ""
   Else
      emailAddr = em
   End If
End Function

Function SafeHTML(s)                                  ' Simple HTML encode type function
   sh = Server.HTMLEncode(s)                          ' Just uses MS function for now
   If IsNull(sh) Then SafeHTML = "" Else SafeHTML = sh
End Function

Function Dbg(Key, Value)                              ' Output debug info
   Response.Write("<tr><td><b>"& SafeHTML(Key) & "</b></td><td>" & SafeHTML(Value) & "&nbsp;</td></tr>" & VBCRLF)
End Function

Set iMsg = CreateObject("CDO.Message")
Set iConf = CreateObject("CDO.Configuration")
Set Flds = iConf.Fields

With Flds
   .Item("http://schemas.microsoft.com/cdo/configuration/sendusing")   = 2
   .Item("http://schemas.microsoft.com/cdo/configuration/smtpserver")  = SMTPServer
   If PreserveCookies Then
      hc = ""
      For Each strKey In Request.Cookies
            hc = hc & strKey & "=" & Request.Cookies(strKey) & "; "
      Next      
      .Item("http://schemas.microsoft.com/cdo/configuration/httpcookies") = hc
   End If
   .Update
End With

With iMsg
   Set .Configuration = iConf
   .To = emailAddr(RequestEx("cdoTo"))
   .From = EmailAddrFrom(emailAddr(RequestEx("cdoFrom")))
   .CC = emailAddr(RequestEx("cdoCC"))
   .BCC = emailAddr(RequestEx("cdoBCC"))
   .Subject = RequestEx("cdoSubject")

   If RequestEx("cdoEmailURL") = "" Then
      If RequestEx("cdoHTMLBody") <> "" Then
         .HTMLBody = RequestEx("cdoHTMLBody")
      ElseIf RequestEx("cdoTextBody") <> "" Then
         .TextBody = RequestEx("cdoTextBody")
      Else      
         If HTMLMail Then
            Body = "<html><head><style>td { font-family: Arial; font-size: 10pt;}</style></head>" & VBCRLF
            Body = Body & "<body>" & VBCRLF
            Body = Body & "<table border=""0"" cellpadding=""0"" cellspacing=""2"">" & VBCRLF
         End If
      
         For I = 1 to Request.Form.Count
            FName = Request.Form.Key(I)                           ' Field Name
            FValue = Request.Form.Item(I)                         ' Field Value
            
            If (Left(FName,Len(AllowPrefix)) = AllowPrefix _      
            OR AllowPrefix = "") AND FValue <> "" Then                           ' ALLOW Rules
            If (NOT (Left(FName,Len(DenyPrefix)) = DenyPrefix) _  
             OR DenyPrefix = "") AND FValue <> "" AND Not InDenyList(FName) Then ' DENY Rules
               IF HTMLMail Then
                  Body = Body & "<tr><td valign=""Top""><b>" & SafeHTML(Mid(FName, Len(AllowPrefix)+1)) _
                              & "</b></td>" & VBCRLF
                  Body = Body & "<td width=""15"">&nbsp;</td>" & VBCRLF
                  Body = Body & "<td>" & SafeHTML(FValue) & "</td></tr>" & VBCRLF
               Else
                  Body = Body & FName & ":   " _
                  & FValue & vbCRLF
               End IF
            End If
            End If
         Next  
      
         IF HTMLMail Then
            Body = Body & "</table></body></html>" & VBCRLF
            .HTMLBody = Body
         Else
            .TextBody = Body
         End If
      End If
   Else
   	'Response.Write RequestEx("cdoEmailUrl")
   	'Response.End
      .CreateMHTMLBody RequestEx("cdoEmailUrl")
   End If

   If DebugEnable Then
      Response.Write "<table border=1 style=""font-family: Arial; font-size: 10pt;"">" & VBCrLf

      Dbg   "cdoTo (formatted)", emailAddr(RequestEx("cdoTo"))
      Dbg   "cdoFrom (formatted)", EmailAddrFrom(emailAddr(RequestEx("cdoFrom")))
      Dbg   "cdoCC (formatted)", emailAddr(RequestEx("cdoCC"))
      Dbg   "cdoBCC(formatted)", emailAddr(RequestEx("cdoBCC"))
      
      For Each p in ParamList
         Dbg p, RequestEx(p)
      Next
      Dbg "SessionID", Session.SessionID
      Dbg "Raw Headers", Request.ServerVariables("ALL_RAW")
      Dbg "Cookie", hc
      Dbg "Body", body
      Response.Write "</table>"
      Response.Flush
   End If

   .Send
   
   If Err.Number = "" or Err.Number = "0" Then
      If RequestEx("cdoSuccessURL") = "" Then %>
         <PRE>Message sent successfully</PRE><%
      Else
         If DebugEnable Then 
%>
            DebugEnable mode: Skipping redirect to <%=RequestEx("cdoSuccessURL")%> </PRE>
            Message sent successfully<%
         Else
            Response.Redirect Request("cdoSuccessURL")
         End If
      End If
   Else
      If RequestEx("cdoFailureURL") = "" Then %>
         <PRE>There was a problem processing this submission. Please contact support</PRE><%
      Else
         If DebugEnable Then %><br>
            DebugEnable mode: Skipping redirect to <%=RequestEx("cdoFailureURL")%><br><br>
            Message failed<br>
            Error Number: <%=Err.Number%><br>
            Error Description: <%=Err.Description%><br>
            <%
         Else
            Response.Redirect RequestEx("cdoFailureURL")
         End If
      End If
   End If   
   If DebugEnable Then
      Response.Write "</P>"
   End If
End With
%>